<?php
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////

class UlitkaLoginScreen implements UserInputHandler
{
    const ID = 'login';
	
    private $vod;
    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }
    
    public function set_vod($vod)
    {
        $this->vod = $vod;
    }

    public function get_handler_id()
    { return self::ID; }

    protected function add_button(&$defs,
        $name, $title, $caption, $width)
    {
        ControlFactory::add_button($defs, $this, null,
            $name, $title, $caption, $width);
    }

    protected function add_combobox(&$defs,
        $name, $title, $initial_value, $value_caption_pairs, $width,
        $need_confirm = false, $need_apply = false)
    {
        ControlFactory::add_combobox($defs, $this, null,
            $name, $title, $initial_value, $value_caption_pairs, $width,
            $need_confirm, $need_apply);
    }

    protected function add_label(&$defs, $title, $text)
    {
        ControlFactory::add_label($defs, $title, $text);
    }

    protected function add_text_field(&$defs,
        $name, $title, $initial_value,
        $numeric, $password, $has_osk, $always_active, $width,
        $need_confirm = false, $need_apply = false)
    {
        ControlFactory::add_text_field($defs, $this, null,
            $name, $title, $initial_value,
            $numeric, $password, $has_osk, $always_active, $width,
            $need_confirm, $need_apply);
    }

    protected function add_close_dialog_and_apply_button(&$defs,
        $name, $caption, $width)
    {
        $params = array('button_caption_centered' => 1);
        ControlFactory::add_close_dialog_and_apply_button($defs,
            $this, null,
            $name, $caption, $width, $params);
    }

    protected function add_close_dialog_button(&$defs,
        $caption, $width)
    {
        $params = array('button_caption_centered' => 1);
        ControlFactory::add_close_dialog_button($defs,
            $caption, $width, $params);
    }

    public function do_get_control_defs(&$plugin_cookies, $reset_controls = false)
    {
        $defs = array();

        $username = isset($plugin_cookies->username) ? $plugin_cookies->username : '';
        $password = isset($plugin_cookies->password) ? $plugin_cookies->password : '';

        $this->add_text_field($defs,
            'login', 'Имя пользователя:',
            $username, 0, 0, 0, 1, 600, 0, false);
        $this->add_text_field($defs,
            'pass', 'Пароль:',
            $password, 0, 1, 0, 1, 600, 0, false);

        $this->add_label($defs, "", "'D' - вызов клавиатуры");
        
        $this->add_close_dialog_and_apply_button($defs,
            'login_apply', 'ОК', 200);
        $this->add_close_dialog_button($defs,
            'Отмена', 200);
 
        return $defs;
    }

    public function get_control_defs(&$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Login: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        if (!isset($user_input->control_id))
            return null;

        $control_id = $user_input->control_id;
        
        if ($user_input->action_type === 'apply')
        {
            if ($control_id === 'login_apply')
            {
                if ($user_input->login == '' || $user_input->pass == '')
                    return null;
                    
                $uid = UlitkaApi::Login($vip, $plugin_cookies, $user_input->login, $user_input->pass);
                if (!$uid)
                {
                    return ActionFactory::show_error(false, 'Вход', array('Не верный логин или пароль'));
                }

                if (isset($this->vod))
                {
                    $this->vod->uid = $uid;
                    $this->vod->vip = $vip;
                }   
                $plugin_cookies->username = $user_input->login;
                $plugin_cookies->password = $user_input->pass;

                return ActionFactory::open_folder('vod_category_list');
            }
        }
        
        return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies, true));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
