<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';

require_once 'lib/vod/vod_list_screen.php';
require_once 'skins/skins.php';

require_once 'Ulitka_config.php';

require_once 'Ulitka_api.php';
//require_once 'Ulitka_main_menu_screen.php';
require_once 'Ulitka_vod.php';
require_once 'Ulitka_setup_screen.php';
require_once 'Ulitka_search_history.php';
require_once 'Ulitka_vod_category_list_screen.php';
require_once 'Ulitka_vod_list_screen.php';
require_once 'Ulitka_vod_series_list_screen.php';
require_once 'Ulitka_vod_favorites_screen.php';
require_once 'Ulitka_vod_movie_screen.php';
require_once 'Ulitka_login_screen.php';

///////////////////////////////////////////////////////////////////////////

class UlitkaPlugin extends DefaultDunePlugin
{
    private $skins;
    private $login;
    
    public function __construct()
    {
        $plugin_path = dirname(__FILE__);
        $this->skins = new UlitkaSkins($plugin_path, $plugin_path . '/skins');
        $this->login = new UlitkaLoginScreen();
        $this->vod = new UlitkaVod($this->login, $this->skins);
        $this->login->set_vod($this->vod);
        
//        $this->add_screen(new UlitkaMainMenuScreen($this->vod, $this->skins, $this->login));
        $this->add_screen(new UlitkaSetupScreen($this->skins));
        $this->add_screen(new UlitkaVodCategoryListScreen($this->vod, $this->skins));
        $this->add_screen(new UlitkaVodListScreen($this->vod, $this->skins));
        $this->add_screen(new Ulitka_search_history($this->vod, $this->skins));
        $this->add_screen(new UlitkaVodFavoritesScreen($this->vod, $this->skins));

        $this->add_screen(new UlitkaVodMovieScreen($this->vod));
        $this->add_screen(new UlitkaVodSeriesListScreen($this->vod));
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        if (isset($user_input->control_id) && $user_input->control_id == 'start')
        {
            $this->vod->userid = UlitkaApi::Login($this->vod->vip, $plugin_cookies);
            
            if ($this->vod->userid == 0)
            {
                return ActionFactory::show_dialog("Ulitka.tv - Авторизация", $this->login->get_control_defs($plugin_cookies), true);
            }
  
            return ActionFactory::open_folder($user_input->selected_media_url);
        }

        return UserInputHandlerRegistry::get_instance()->handle_user_input(
            $user_input, $plugin_cookies);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
